Main Page Modules Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# deSceneObject Class Reference

`#include <deScene_priv.hpp>`

Inheritance diagram for deSceneObject:

[legend]
Collaboration diagram for deSceneObject:

[legend]
List of all members.

## Public Member Functions
| deSceneObject (interface_t myType)
virtual | ~deSceneObject ()
IdeSceneObject::interface_t | GetSOIType ()
void * | GetSOInterface (IdeSceneObject::interface_t i)
void * | GetWOInterface (long interface_id)
deBoolean | Serialize (IdeFile *FS)
| Serialize the object into an open IdeFile - used by deWorld internally.
deBoolean | DeSerialize (IdeFile *FS, long DataLength, u32 &AmtRead)
deBoolean | DeSerializeLoad ()
void | PreCache (IdeDriver *)
long | Traverse (IdeSceneGraph::deSceneTraversal *Params)
void | SetActivation (activate_t a_type, deBoolean Active)
| Set the activation state of the object.
deBoolean | GetActivation (activate_t a_type) const
| Retrieve the activation state of the object.
void | SetWorldTransform (const deTransformInfo &mat)
| set the world transformation of this object
deVec3d | GetBoundCenter ()
deVec3d | GetOccludeCenter ()
void | GetWorldTransform (deTransformInfo &mat)
void | GetWorldPos (deVec3d &PosVector)
deVec3d | GetWorldBoundCenter ()
deVec3d | GetWorldOccludeCenter ()
deDouble | GetBoundRadius ()
deDouble | GetOccludeRadius ()
void | GetLocalAABB (deAABB &bbox)
| retrieve the local AABB (computed as the extents of the object on its local axes)
void | GetWorldOBB (deOBB &bbox)
| retrieve the oriented bounding box in world coordinates (local AABB transformed into world space)
void | GetWorldAABB (deAABB &bbox)
deBoolean | IsTransparent ()
deBoolean | OccludesObject (deVec3d &position, IdeSceneObject *so, deVec3d &NormalizedDisplacement)
long | GetCurrentPassNum () const
deBoolean | AddRoomReference (IdeSceneRoom *ref, void *ptr)
void * | GetRoomReference (IdeSceneRoom *ref)
deBoolean | RemoveRoomReference (IdeSceneRoom *ref)
## Protected Member Functions
virtual long | TraverseForRender (IdeSceneGraph::deSceneTraversal *Params)=0
void | SetBoundCenter (deVec3d)
void | SetOccludeCenter (deVec3d)
void | SetBoundRadius (deDouble)
void | SetOccludeRadius (deDouble)
void | SetWorldCenters ()
void | SetLocalAABB (deVec3d min, deVec3d max)
deVec3d | CalcAverageCenter (deVec3d points[], long count)
deDouble | CalcBoundRadius (deVec3d points[], long count)
deDouble | CalcOccludeRadius (deVec3d points[], long count)
void | CalcLocalAABB (deVec3d points[], long count, deVec3d &min, deVec3d &max)
void | CalcAllValues (deVec3d points[], long count)
void | SetTransparent (deBoolean Transparent)
IdeLineBrush * | GetBoundLine ()
const deTransformInfo & | GetWorldTransform ()
## Protected Attributes
deTransform | m_WorldTransform
deDouble | m_BoundRadius
deDouble | m_OccludeRadius
deVec3d | m_BoundCenter
deVec3d | m_OccludeCenter
deAABB | m_AABB
deVec3d | m_WorldBound
deVec3d | m_WorldOcclude
deBoolean | m_Transformed
deBoolean | m_Transparent
deBoolean | m_Active [activate_count]
long | m_CurrentPassNum
const interface_t | m_Interface
## Private Attributes
IdeLineBrush * | m_BoundLine
deTArray< RoomEntry > | m_RoomList

## Constructor & Destructor Documentation

deSceneObject::deSceneObject | ( | interface_t | myType | ) |

deSceneObject::~deSceneObject | ( |  | ) | `[virtual]`

## Member Function Documentation

deBoolean deSceneObject::AddRoomReference | ( | IdeSceneRoom * | ref,
|  | void * | ptr
| ) | `[virtual]`

| Implements IdeSceneObject.

void deSceneObject::CalcAllValues | ( | deVec3d | points[],
|  | long | count
| ) | `[protected]`

deVec3d deSceneObject::CalcAverageCenter | ( | deVec3d | points[],
|  | long | count
| ) | `[protected]`

deDouble deSceneObject::CalcBoundRadius | ( | deVec3d | points[],
|  | long | count
| ) | `[protected]`

void deSceneObject::CalcLocalAABB | ( | deVec3d | points[],
|  | long | count,
|  | deVec3d & | min,
|  | deVec3d & | max
| ) | `[protected]`

deDouble deSceneObject::CalcOccludeRadius | ( | deVec3d | points[],
|  | long | count
| ) | `[protected]`

deBoolean deSceneObject::DeSerialize | ( | IdeFile * | FS,
|  | long | DataLength,
|  | u32 & | AmtRead
| ) |

deBoolean deSceneObject::DeSerializeLoad | ( |  | ) | `[virtual]`

| Call after all objects in a world have been loaded, to allow pointers to be correctly resolved from World and Object ID's Reimplemented from deWorldObject. Reimplemented in deSceneABT, deSceneTerrain, deSceneSky, and deSceneStaticMesh.

deBoolean deSceneObject::GetActivation | ( | activate_t | a_type | ) | const`[virtual]`

| Retrieve the activation state of the object. Implements IdeSceneObject.

deVec3d deSceneObject::GetBoundCenter | ( |  | ) | `[virtual]`

| Implements IdeSceneObject.

IdeLineBrush * deSceneObject::GetBoundLine | ( |  | ) | `[protected]`

deDouble deSceneObject::GetBoundRadius | ( |  | ) | `[virtual]`

| Implements IdeSceneObject.

long deSceneObject::GetCurrentPassNum | ( |  | ) | const`[virtual]`

| Implements IdeSceneObject.

void deSceneObject::GetLocalAABB | ( | deAABB & | bbox | ) | `[virtual]`

| retrieve the local AABB (computed as the extents of the object on its local axes) Implements IdeSceneObject.

deVec3d deSceneObject::GetOccludeCenter | ( |  | ) | `[virtual]`

| Implements IdeSceneObject.

deDouble deSceneObject::GetOccludeRadius | ( |  | ) | `[virtual]`

| Implements IdeSceneObject.

void * deSceneObject::GetRoomReference | ( | IdeSceneRoom * | ref | ) | `[virtual]`

| Implements IdeSceneObject.

void* deSceneObject::GetSOInterface | ( | IdeSceneObject::interface_t | i | ) | `[virtual]`

| Implements IdeSceneObject. Reimplemented in deSceneABT, deSceneTerrain, deSceneSky, deSceneAnimatedMesh, deSceneStaticMesh, deSceneActor, and deSceneLight.

IdeSceneObject::interface_t deSceneObject::GetSOIType | ( |  | ) | `[virtual]`

| Implements IdeSceneObject. Reimplemented in deSceneABT, deSceneTerrain, deSceneSky, deSceneAnimatedMesh, deSceneStaticMesh, deSceneActor, and deSceneLight.

void * deSceneObject::GetWOInterface | ( | long | interface_id | ) | `[virtual]`

| request a related interface, identified with an ID originally returned from IdeWorldManager::GetUniqueWOInterfaceID Implements IdeWorldObject.

void deSceneObject::GetWorldAABB | ( | deAABB & | bbox | ) | `[virtual]`

| retrieve the world AABB of the object. This AABB is guaranteed to contain the world OBB for the current orientation, and may contain the OBB no matter what its orientation. Implements IdeSceneObject.

deVec3d deSceneObject::GetWorldBoundCenter | ( |  | ) | `[virtual]`

| Implements IdeSceneObject.

void deSceneObject::GetWorldOBB | ( | deOBB & | bbox | ) | `[virtual]`

| retrieve the oriented bounding box in world coordinates (local AABB transformed into world space) Implements IdeSceneObject.

deVec3d deSceneObject::GetWorldOccludeCenter | ( |  | ) | `[virtual]`

| Implements IdeSceneObject.

void deSceneObject::GetWorldPos | ( | deVec3d & | PosVector | ) | `[virtual]`

| Implements IdeSceneObject.

const deTransformInfo & deSceneObject::GetWorldTransform | ( |  | ) | `[protected]`

void deSceneObject::GetWorldTransform | ( | deTransformInfo & | mat | ) | `[virtual]`

| retrieve the world transformation of this object. All bounding volumes are relative to the translation of this Implements IdeSceneObject.

deBoolean deSceneObject::IsTransparent | ( |  | ) | `[virtual]`

| Implements IdeSceneObject.

deBoolean deSceneObject::OccludesObject | ( | deVec3d & | position,
|  | IdeSceneObject * | so,
|  | deVec3d & | NormalizedDisplacement
| ) | `[virtual]`

| Implements IdeSceneObject.

void deSceneObject::PreCache | ( | IdeDriver * |  | ) | `[inline, virtual]`

| Implements IdeSceneObject. Reimplemented in deSceneTerrain.

deBoolean deSceneObject::RemoveRoomReference | ( | IdeSceneRoom * | ref | ) | `[virtual]`

| Implements IdeSceneObject.

deBoolean deSceneObject::Serialize | ( | IdeFile * | FS | ) | `[virtual]`

| Serialize the object into an open IdeFile - used by deWorld internally. Implements IdeWorldObject.

void deSceneObject::SetActivation | ( | activate_t | a_type,
|  | deBoolean | Active
| ) | `[virtual]`

| Set the activation state of the object. Implements IdeSceneObject.

void deSceneObject::SetBoundCenter | ( | deVec3d |  | ) | `[protected]`

void deSceneObject::SetBoundRadius | ( | deDouble |  | ) | `[protected]`

void deSceneObject::SetLocalAABB | ( | deVec3d | min,
|  | deVec3d | max
| ) | `[protected]`

void deSceneObject::SetOccludeCenter | ( | deVec3d |  | ) | `[protected]`

void deSceneObject::SetOccludeRadius | ( | deDouble |  | ) | `[protected]`

void deSceneObject::SetTransparent | ( | deBoolean | Transparent | ) | `[protected]`

| Reimplemented in deSceneStaticMesh.

void deSceneObject::SetWorldCenters | ( |  | ) | `[protected]`

void deSceneObject::SetWorldTransform | ( | const deTransformInfo & | mat | ) | `[virtual]`

| set the world transformation of this object Implements IdeSceneObject. Reimplemented in deSceneLight.

long deSceneObject::Traverse | ( | IdeSceneGraph::deSceneTraversal * | Params | ) | `[virtual]`

| Implements IdeSceneObject.

virtual long deSceneObject::TraverseForRender | ( | IdeSceneGraph::deSceneTraversal * | Params | ) | `[protected, pure virtual]`

| Implemented in deSceneABT, deSceneTerrain, deSceneSky, deSceneAnimatedMesh, deSceneStaticMesh, deSceneActor, and deSceneLight.

## Member Data Documentation

deAABB deSceneObject::m_AABB`[protected]`

deBoolean deSceneObject::m_Active[activate_count]`[protected]`

deVec3d deSceneObject::m_BoundCenter`[protected]`

IdeLineBrush* deSceneObject::m_BoundLine`[private]`

deDouble deSceneObject::m_BoundRadius`[protected]`

long deSceneObject::m_CurrentPassNum`[protected]`

const interface_t deSceneObject::m_Interface`[protected]`

deVec3d deSceneObject::m_OccludeCenter`[protected]`

deDouble deSceneObject::m_OccludeRadius`[protected]`

deTArray<RoomEntry> deSceneObject::m_RoomList`[private]`

deBoolean deSceneObject::m_Transformed`[protected]`

deBoolean deSceneObject::m_Transparent`[protected]`

deVec3d deSceneObject::m_WorldBound`[protected]`

deVec3d deSceneObject::m_WorldOcclude`[protected]`

deTransform deSceneObject::m_WorldTransform`[protected]`

The documentation for this class was generated from the following files:

- deScene_priv.hpp
- deSolidObject.cpp